--barra laverda serie C
--#autor: Asd4
--$data: 03/11/2011r.
CRX = {};

function CRX.prerequisitesPresent(specializations)
    return true;
end;

function CRX:load(xmlFile)


	self.DJoint = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.DSblade#DJoint"), 1);
	self.DOrientation = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.DSblade#Orientation"));

	self.SJoint2 = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.DSblade2#SJoint2"), 2);
	self.SOrientation2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.DSblade2#Orientation2"));
	-- Sounds --
	
    BsSoundFile = Utils.getFilename("hydraulic.wav", self.baseDirectory);
    self.BsSoundId = createSample("hydraulic");
    loadSample(self.BsSoundId, BsSoundFile, false);
    self.BsPlaying = false;
	
    PsSoundFile = Utils.getFilename("cutterx.wav", self.baseDirectory);
    self.PsSoundId = createSample("cutterx");
    loadSample(self.PsSoundId, PsSoundFile, false);
    self.PsPlaying = false;


		self.isSelectable = true;

end;

function CRX:delete()
    delete(self.BsSoundId);
    delete(self.PsSoundId);
    delete(self.PsPlaying);
    delete(self.BsPlaying);
end;

function CRX:mouseEvent(posX, posY, isDown, isUp, button)
end;

function CRX:keyEvent(unicode, sym, modifier, isDown)
end;


function CRX:update(dt)
if self:getIsActiveForInput() then
	if InputBinding.hasEvent(InputBinding.CrxMode) then
            self.EvenMode = not self.EvenMode;
end;
	if self.EvenMode then
		self:setAnimationTime(5, self.animationParts[5].animDuration, false); 
    else
		self:setAnimationTime(5, self.animationParts[5].offSet, false);
        self:setAnimationTime(3, self.animationParts[3].currentPosition-(self.animationParts[3].offSet+dt), false);
        self:setAnimationTime(4, self.animationParts[4].currentPosition-(self.animationParts[4].offSet+dt), false);
	end;
end;
--Animacje
   if self:getIsActiveForInput() then
	    if self.EvenMode then
 	        if InputBinding.isPressed(InputBinding.MOTO1) then
               self:setAnimationTime(3, self.animationParts[3].currentPosition+(self.animationParts[3].offSet+dt), false);
            elseif InputBinding.isPressed(InputBinding.MOTO2) then
               self:setAnimationTime(3, self.animationParts[3].currentPosition-(self.animationParts[3].offSet+dt), false);
        end;
        	if InputBinding.isPressed(InputBinding.MOTO3) then
               self:setAnimationTime(4, self.animationParts[4].currentPosition+(self.animationParts[4].offSet+dt), false);
            elseif InputBinding.isPressed(InputBinding.MOTO4) then
               self:setAnimationTime(4, self.animationParts[4].currentPosition-(self.animationParts[4].offSet+dt), false);
		end;
    end;
end;
	
  if self.reelStarted then  
      self.EvenMode = true;   
      self:setAnimationTime(1, 1);
      self:setAnimationTime(2, 1);
      else
      self:setAnimationTime(1, 0);
      self:setAnimationTime(2, 0);
      end;
      	if self:getIsActiveForInput() then
    if InputBinding.isPressed(InputBinding.MOTO5) then
     if self.animationParts[2].clipSpeed < 5 then
      self.animationParts[2].clipSpeed = self.animationParts[2].clipSpeed+0.01;
	   end;
	  elseif InputBinding.isPressed(InputBinding.MOTO6) then
	    if self.animationParts[2].clipSpeed > 0.5 then
      self.animationParts[2].clipSpeed = self.animationParts[2].clipSpeed-0.01;
	  end;
   end;
   end;
if self:getIsActive() then
		if self.DJoint ~= 0 then
			setJointFrame(self.componentJoints[self.DJoint].jointIndex , 0, self.componentJoints[self.DJoint].jointNode);   
			local x, y, z = getRotation(self.DOrientation);	    
			setRotation(self.DOrientation, 0,y,0);
	 end;
		if self.SJoint2 ~= 0 then
			setJointFrame(self.componentJoints[self.SJoint2].jointIndex , 0, self.componentJoints[self.SJoint2].jointNode);   
			local x, y, z = getRotation(self.SOrientation2);	    
			setRotation(self.SOrientation2, 0,y,0);
	 end;	
end;	
	
	--Sunet
	if self.EvenMode and self:getIsActiveForSound() then
	if InputBinding.isPressed(InputBinding.MOTO1) or InputBinding.isPressed(InputBinding.MOTO2) or InputBinding.isPressed(InputBinding.MOTO3) or InputBinding.isPressed(InputBinding.MOTO4) then 
        if not self.BsPlaying then
            playSample(self.BsSoundId, 0, 0.5, 0);
            self.BsPlaying = true;
        end;
	
	else
        if self.BsPlaying then
            stopSample(self.BsSoundId);
            self.BsPlaying = false;
        end;
    end;
end;
	if self.reelStarted and self:getIsActiveForSound() then
			if not self.PsPlaying then
				playSample(self.PsSoundId, 0, 0.4, 0);
				self.PsPlaying = true;
			end;
		--end;
	else
			if self.PsPlaying then
				stopSample(self.PsSoundId);
				self.PsPlaying = false;
			end;
	end;
end;

function CRX:draw()
end;

function CRX:onDeactivateSounds()
    if self.PsPlaying ~= nil then
		stopSample(self.PsSoundId);
    end;
    if self.BsPlaying ~= nil then
		stopSample(self.BsSoundId);
    end;
end;  
function CRX:validateAttacherJoint(implement, jointDesc, dt)
    return true;
end;

function CRX:onLeave()
end;

function CRX:onDeactivate()
end;
function CRX:setHydraulicDirection(index)
end;